package wj.math;

import java.util.List;
import java.util.ArrayList;

/**

n = sum(d[i]*i!, i=0..j-1)

(((( ... d5*5+d4)*4+d3)*3+d2)*2+d1)*1+d0

d0 = 0

*/
public class FactorialNumber {
	List _d;
	public FactorialNumber()
	{
		_d = new ArrayList();

		setDigit(0,0);
	}
	public FactorialNumber(int n)
	{
		_d = new ArrayList();
		setDigit(0,0);

		int q = n;
		int j = 0;

		while (q!=0)
		{
			setDigit(j, q % (j+1) );
			q = q / (j+1);
			j++;
		}
	}
	public int intValue()
	{
		int result=0;

		for (int j=_d.size()-1 ; j>0 ; j--)
		{
			result = j*(result + getDigit(j));
		}
		result += getDigit(0);	// always == 0

		return result;
	}
	public void setDigit(int i, int d) throws RuntimeException
	{
		if (i==0 && d!=0)
			throw new RuntimeException("FactorialNumber: first digit = " + d + ": must be 0!");
		if (d<0)
			throw new RuntimeException("FactorialNumber: digit = " + d + ": must be >= 0");
		while (_d.size() <= i) _d.add(new Integer(0));
		_d.set(i,new Integer(d));
	}
	public int getDigit(int i)
	{
		return ((Integer)_d.get(i)).intValue();
	}

	public String toString()
	{
		String result = "{";
		result += _d.get(0)+"*"+0+"!";
		for(int i=1 ; i<_d.size() ; i++)
		{
			result += " + " + _d.get(i)+"*"+i+"!";
		}
		result += "}";
		return result;
	}
}
