import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class MainApplet extends java.applet.Applet {

	double h=400;		// height
	double w=600;		// width
	double f=200;		// focus (distance view point - view plane)

	double[] x;

	NSpace s;
	NObject[] objects;
 
	public MainApplet()
	{
		s = new NSpace(3);

		objects = new NObject[2];

		x = new double[]{w/2, -f, h/2};
		s.setViewPoint(NFactory.makePoint(x));

		s.setProjectionPlane(
				NFactory.makePlane(new NObject[]{
						NFactory.makePoint(new double[]{0, 0, 0}),
						NFactory.makePoint(new double[]{0, 0, h}),
						NFactory.makePoint(new double[]{w, 0, h}),
						NFactory.makePoint(new double[]{w, 0, 0}) }));

		objects[0] = NFactory.makePlane(new NObject[]{
				NFactory.makePoint(new double[]{  w/3,   f,   h/3}),
				NFactory.makePoint(new double[]{  w/3, 2*f, 2*h/3}),
				NFactory.makePoint(new double[]{2*w/3, 2*f, 2*h/3}),
				NFactory.makePoint(new double[]{2*w/3,   f,   h/3}) });

		objects[1] = NFactory.makeTetraeder(new NObject[]{
				NFactory.makePoint(new double[]{  w/3,   f,   w/3}),
				NFactory.makePoint(new double[]{2*w/3,   f,   w/3}),
				NFactory.makePoint(new double[]{  w/3, 2*f,   w/3}),
				NFactory.makePoint(new double[]{  w/3,   f, 2*w/3}) });

		addMouseMotionListener(new MouseMotionAdapter() {
			public void mouseDragged(MouseEvent e)
			{
				int x0 = e.getX();
				int y0 = e.getY();

				if (allBitsOn(e.getModifiers(), InputEvent.ALT_MASK|InputEvent.META_MASK))
				{
					x[3]=x0-w/2;
					x[0]=h/2-y0;
				}
				else if (allBitsOn(e.getModifiers(), InputEvent.ALT_MASK))
				{
					x[1]=x0-w/2;
					x[2]=h/2-y0;
				}
				else if (allBitsOn(e.getModifiers(), InputEvent.META_MASK))
				{
					x[2]=x0-w/2;
					x[3]=h/2-y0;
				}
				else
				{
					x[0]=x0-w/2;
					x[1]=h/2-y0;
				}

				s.setViewPoint(NFactory.makePoint(x));

				repaint();
			}
		});
	}

	private boolean anyBitsOn(int value, int bits)
	{
		return (value&bits)!=0;
	}

	private boolean allBitsOn(int value, int bits)
	{
		return (value&bits)==bits;
	}

	public void paint(Graphics g)
	{
		for (int i=0 ; i<objects.length ; i++)
			if (objects[i]!=null)
					objects[i].drawIn(s, g);
		g.drawString(x[0] + " " + x[1] + " " + x[2], 50, 50);
		super.paint(g);
	}
}




