import java.util.*;

public class tetra {
	public static void main(String args[])
	{
		new tetra();
	}

	tetra()
	{
		for (int dim=0 ; dim<10 ; dim++)
		{
			System.out.println("---------------- dim="+dim);
			Set points = make_point_set(dim);
			print_set(points);
			System.out.println("==== freq");

			SortedMap freq = calc_freq(points);
			print_freq(freq);

			System.out.println("==== more");
			Set morepoints = find_more_points(points, dim);
			print_set(morepoints);
		}
	}
	Set find_more_points(Set points, int dim)
	{
		Set morepoints = new HashSet();

		for(int pp=0 ; pp<(1<<dim) ; pp++)
		{
			Integer p = new Integer(pp);
			int n=0;
			for (Iterator i = points.iterator(); i.hasNext() ; n++)
			{
				Integer q = (Integer)i.next();
				Integer d = dist(p, q);
				if (d.intValue()!=2) 
					break;
			}
			if (n==points.size())
				morepoints.add(p);
		}
		return morepoints;
	}
	void print_set(Set points)
	{
		for (Iterator i = points.iterator(); i.hasNext() ; )
		{
			Integer p = (Integer)i.next();
			System.out.print(" "+p);
		}
		System.out.println("");
	}
	Set make_point_set(int dim)
	{
		Set points = new HashSet();
		for (int i=0 ; i<dim ; i++)
			points.add(new Integer((1<<(dim-1)) ^ (1<<i)));

		return points;
	}

	void print_freq(SortedMap freq)
	{
		for(Iterator i=freq.keySet().iterator() ; i.hasNext() ; )
		{
			Integer dist = (Integer)i.next();
			Integer count = (Integer)freq.get(dist);

			System.out.println(dist + " = " + count);
		}
	}

	SortedMap calc_freq(Set points)
	{
		SortedMap dist_freq = new TreeMap();

		for (Iterator i = points.iterator(); i.hasNext() ; )
		{
			Integer p = (Integer)i.next();
			for (Iterator j = points.iterator(); j.hasNext() ; )
			{
				Integer q = (Integer)j.next();
				Integer d = dist(p, q);
				Integer count;
				if (dist_freq.containsKey(d))
					count = (Integer)dist_freq.get(d);
				else
					count = new Integer(0);
				dist_freq.put(d, new Integer(count.intValue()+1));
			}
		}
		return dist_freq;
	}

	Integer dist(Integer p, Integer q)
	{
		return new Integer(count_bits(p.intValue()^q.intValue()));
	}
	int count_bits(int w)
	{
		int count=0;
		for (count=0 ; w>0 ; w>>>=1)
			if ((w&1)!=0)
				count++;
		return count;
	}

}
