import java.util.List;
import java.util.Iterator;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextArea;
import javax.swing.BorderFactory;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;

import wj.math.Matrix;
import wj.math.shapes.PolyObject;
import wj.math.shapes.Tetraeder;
import wj.math.shapes.Hexaeder;
import wj.math.shapes.Octaeder;
import wj.math.shapes.Point;

public class polytope implements ActionListener {
	JTextArea _textarea;
	JComboBox _dimensionCombo;
	JComboBox _typeCombo;
/*
	JSlider _xslide;
	JSlider _yslide;
*/
	public static void main(String[] args)
	{
		new polytope();
	}
	polytope() {
		buildFrame();
	}

	JFrame buildFrame()
	{
		JFrame frame = new JFrame("polytope");

		frame.getContentPane().add(buildForm(), BorderLayout.CENTER);
		frame.addWindowListener(
				new WindowAdapter() {
					public void windowClosing(WindowEvent e) {
						System.exit(0);
					}
				}
			);
		frame.pack();
		frame.setVisible(true);

		return frame;
	}

	Component buildForm()
	{
		JPanel pane = new JPanel();
		GridBagConstraints c = new GridBagConstraints();

		pane.setBorder(BorderFactory.createEmptyBorder(30, 30, 10, 30));
		pane.setLayout(new GridBagLayout());

		c.anchor = GridBagConstraints.NORTHWEST;
		c.gridwidth = 1;
		pane.add(new JLabel("dimension"), c);

		c.anchor = GridBagConstraints.NORTHWEST;
		c.gridwidth = 1;
		pane.add(_dimensionCombo = new JComboBox(), c);
		for (int i=0 ; i<8 ; i++)
			_dimensionCombo.addItem(Integer.toString(i));
		_dimensionCombo.setEditable(true);

		c.anchor = GridBagConstraints.NORTHWEST;
		c.gridwidth = 1;
		pane.add(new JLabel("shape"), c);

		c.anchor = GridBagConstraints.NORTHWEST;
		c.gridwidth = 1;
		pane.add(_typeCombo = new JComboBox(), c);
		_typeCombo.addItem("tetra");
		_typeCombo.addItem("hexa");
		_typeCombo.addItem("octa");
		_typeCombo.addItem("testtetra");
/*
		c.anchor = GridBagConstraints.SOUTHWEST;
		c.gridwidth = 1;
		pane.add(_xslide = new JSlider(JSlider.HORIZONTAL), c);

		c.anchor = GridBagConstraints.SOUTHWEST;
		c.gridwidth = 1;
		pane.add(_yslide = new JSlider(JSlider.HORIZONTAL), c);
*/
		c.anchor = GridBagConstraints.NORTHWEST;
		c.gridwidth = GridBagConstraints.REMAINDER;
		JButton b = new JButton("generate");
		b.addActionListener(this);
		pane.add(b, c);

		c.anchor = GridBagConstraints.SOUTH;
		c.gridwidth = GridBagConstraints.REMAINDER;
		pane.add(new JScrollPane(_textarea = new JTextArea(25, 80)), c);
		_textarea.setLineWrap(true);


		return pane;
	}
	void print(String s)
	{
		_textarea.append(s);
	}

	public void actionPerformed(ActionEvent e)
	{
		int dimension = _dimensionCombo.getSelectedIndex();
		int type = _typeCombo.getSelectedIndex();
		PolyObject object;

		switch(type)
		{
			case 0: object = Tetraeder.make(dimension); break;
			case 1: object = Hexaeder.make(dimension); break;
			case 2: object = Octaeder.make(dimension); break;
			case 3: object = Tetraeder.make(dimension); break;
			default: return;
		}

		print(object.toString() + "\n");
		System.out.println(object.toString());
		for (int i=0 ; i<=dimension ; i++)
		{
			print(i + " : " + object.components(i).size() + "\n");
		}

		if (type==3)
		{
			List points = object.components(0);
			for (Iterator i=points.iterator() ; i.hasNext() ;)
			{
				Point p = (Point)i.next();
				for (Iterator j=points.iterator() ; j.hasNext() ;)
				{
					Point q = (Point)j.next();
					if (p!=q)
						System.out.println(p.vector().distance(q.vector()));
				}
			}
		}
	}
}


