package wj.math.shapes;

import java.util.List;
import wj.math.NVector;

public class Hexaeder extends PolyObject {
	public Hexaeder(PolyObject parent, int dimension, String name)
	{
		super(parent, dimension, name);
// assume name.length()==2^dimension

		if (dimension==0)
			return;

		Shape part1 = findPoly(dimension-1, _name.substring(0,_name.length()/2));
		add(part1);
		Shape part2 = findPoly(dimension-1, _name.substring(_name.length()/2));
		add(part2);

		List old1 = part1.components(dimension-2);
		List old2 = part2.components(dimension-2);

//			ASSERT(old1.size() == old2.size());

		// PROBLEM: when creating in findpoly, it is not yet part of the root.
		//  findpoly(0123) will only get added to 01234567 when it is
		//     completely finished. this causes f.i. the point 0
		//     not to be found, even after is is created.
		for (int j=0 ; j<old1.size() ; j++)
		{
			Shape comp1 = (Shape)old1.get(j);
			Shape comp2 = (Shape)old2.get(j);
			add(findPoly(dimension-1, comp1.name() + comp2.name()));
		}
	}
	public static Hexaeder make(int dimension)
	{
		return new Hexaeder(null, dimension, "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_$".substring(0, 1<<dimension ));
	}

	protected PolyObject newInstance(PolyObject parent, int dimension, String name)
	{
		return new Hexaeder(parent, dimension, name);
	}
	protected NVector getCoordinates(String name) throws RuntimeException
	{
		NVector vector = new NVector(spaceDimension());

		char c = name.charAt(0);
		int value = 0;

		if (c>='0' && c<='9')
			value = c-'0';
		else if (c>='A' && c<='Z')
			value = c-'A' + 10;
		else if (c>='a' && c<='z')
			value = c-'a' + 26 + 10;
		else if (c=='_')
			value = 26+26+10;
		else if (c=='$')
			value = 1+26+26+10;
		else
		{
			throw new RuntimeException("unknown Point name: \'"+name+"\'");
		}

		for (int i=0 ; i<spaceDimension() ; i++)
		{
			if ((value & 1)!=0)
				vector.set(i, Hexaeder.SCALE);
			value>>=1;
		}
		return vector;
	}

	private final static double SCALE=1.0;
}
