package wj.math.shapes;

import wj.math.NVector;

public class Line extends Shape {
/*
 *	this constructor is used when it is part of a PolyObject.
 */
	public Line(PolyObject parent, String name)
	{
		super(parent, 1, name);
// assert name.length()==2

		for (int i=0 ; i<name.length() ; i++)
		{
			add(_parent.findPoly(0, name.substring(i,i+1)));
		}
	}
/*
 *	general line constructor
 */
	public Line(PolyObject parent, Point p0, Point p1, String name)
	{
		super(parent, 0, name);
		add(p0);
		add(p1);
	}

	public Line(NVector p0, NVector p1)
	{
		super(null,1,"");
		add(new Point(p0));
		add(new Point(p1));
	}
	public Point start()
	{
		return (Point)_components.get(0);
	}
	public Point end()
	{
		return (Point)_components.get(1);
	}

	public NVector startVector()
	{
		return ((Point)_components.get(0)).vector();
	}
	public NVector endVector()
	{
		return ((Point)_components.get(1)).vector();
	}
	public NVector direction()
	{
		return this.endVector().substract(this.startVector());
	}
}
