package wj.math.shapes;

import java.util.List;
import wj.math.NVector;

public class Octaeder extends PolyObject {
	public Octaeder(PolyObject parent, int dimension, String name)
	{
		super(parent, dimension, name);
// assume name.length()==2*dimension
// assume dimension>=0
		if (dimension==0)
			return;

		Point pointz = (Point)findPoly(0, _name.substring(0,1));
		Point pointZ = (Point)findPoly(0, _name.substring(_name.length()-1, _name.length()));
		if (dimension==1)
		{
			add(pointz);
			add(pointZ);
			return;
		}
		
		Shape baseOcta = findPoly(dimension-1, _name.substring(1, _name.length()-1));

		List planelist = baseOcta.components(dimension-2);

		for (int j=0 ; j<planelist.size() ; j++)
		{
			Shape plane = (Shape)planelist.get(j);

			add(new Tetraeder(this, dimension-1, plane.name()+pointz.name()));
			add(new Tetraeder(this, dimension-1, plane.name()+pointZ.name()));
		}

	}
	public static Octaeder make(int dimension)
	{
		return new Octaeder(null, dimension, "zyxwvutsrqponmlkjihgfedcbaABCDEFGHIJKLMNOPQRSTUVWXYZ".substring(26-dimension, 26+dimension));
	}

	protected PolyObject newInstance(PolyObject parent, int dimension, String name)
	{
		return new Octaeder(parent, dimension, name);
	}
	protected NVector getCoordinates(String name) throws RuntimeException
	{
		NVector vector = new NVector(spaceDimension());
		char c = name.charAt(0);

		if (c>='a' && c<='z')
			vector.set(c-'a', -Octaeder.SCALE);
		else if (c>='A' && c<='Z')
			vector.set(c-'A', +Octaeder.SCALE);
		else
		{
			throw new RuntimeException("Octaeder: invalid point name: \'"+name+"\'");
		}
		return vector;
	}
	private final static double SCALE=1.0;
}
