package wj.math.shapes;

import wj.math.NVector;
import wj.math.Matrix;
import java.util.List;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.SortedSet;
import java.util.TreeSet;

public abstract class PolyObject extends Shape {
	public PolyObject(PolyObject parent, int dimension, String name)
	{
		super(parent, dimension, name);
	}

/*
 *
 *- coordinaten moeten aan root-object gevraagd worden
 *- naam vh punt moet dus mee gegeven worden.
 *- root-object moet het met de virtual method 'getCoor...' vragen.
 *
 */

/*
 *	all PolyObjects need to implement a getCoordinates method,
 *	to convert its point names to coordinates.
 */
	protected abstract NVector getCoordinates(String name) throws RuntimeException;
/*
 *	all PolyObjects need to implement a newInstance method,
 *	to provide a virtual constructor.
 */
	protected abstract PolyObject newInstance(PolyObject parent, int dimension, String name);

/*
 *	searches for a PolyObject, create it if it was nog found.
 *
 *	only called for the root objects.
 */
	public Shape findPoly(int dimension, String name)
	{
		Shape component = null;

		component = find(dimension, name);
		if (component==null)
		{
			if (!isRoot())
			{
				System.out.println(" "+toShortString()+".findPoly: "+rootPoly().toShortString()+".findPoly("+name+")");
				component = _parent.findPoly(dimension, name);
			}
		}


		if (component==null)
		{
			if (dimension==0)
			{
				System.out.println(" "+toShortString()+".findPoly: new Point("+rootPoly().toShortString()+","+name+")");
				component = new Point(this, rootPoly().getCoordinates(name), name);
			}
			else if (dimension==1)
			{
				System.out.println(" "+toShortString()+".findPoly: new Line("+rootPoly().toShortString()+","+name+")");
				component = new Line(this, name);
			}
			else
			{
				System.out.println(" "+toShortString()+".findPoly: newInstance("+rootPoly().toShortString()+","+name+")");
				component = newInstance(this, dimension, name);
			}
		}
		return component;
	}
}
