package wj.space;

import wj.math.NVector;
import wj.math.shapes.Shape;
import wj.math.shapes.Line;
import wj.math.shapes.Point;
import wj.math.Matrix;
import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.List;
import java.util.ArrayList;
import java.util.Stack;
import java.awt.Graphics;

public class NObject {
//	public static NObject make(Shape o, NVector translate, double scale)
	public NObject(Shape o, NVector translate, double scale)
	{
		_parts = new ArrayList();
		_parts.add(o);

		_translate = translate;
		_scale = scale;
	}

	public void drawIn(NSpace s, Graphics g)
	{
		System.out.println("Drawing objects");
		for (Iterator p=_parts.iterator() ; p.hasNext() ;)
		{
			Shape o = (Shape)p.next();
//			System.out.println("Drawing object "+o);
			for (Iterator i=o.components(1).iterator() ; i.hasNext() ; )
			{
				Line line = (Line)i.next();
				s.drawLine(g, line.start().vector().transform(_translate, _scale), line.end().vector().transform(_translate, _scale));
			}

			for (Iterator i=o.components(0).iterator() ; i.hasNext() ; )
			{
				Point point = (Point)i.next();
				s.drawPoint(g, point.vector().transform(_translate, _scale));
			}
		}
	}
	private List _parts;

	private NVector _translate;
	private double _scale;

}
