// this class depends on
//	primitive type
//		double
//		int
//	classes
//		java.awt.Frame;
//		java.awt.Graphics;
//		java.awt.event.WindowAdapter;
//		java.awt.event.WindowEvent;
//		java.awt.event.MouseMotionAdapter;
//		java.awt.event.MouseEvent;
//		java.lang.String
//		NSpace
//		NObject
//		NFactory
//		NVector


import java.awt.Frame;
import java.awt.Graphics;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseEvent;

class Main extends Frame {
	public static void main(String args[])
	{
		new Main();
	}

	double h=400;		// height
	double w=600;		// width
	double f=200;		// focus (distance view point - view plane)

	NVector x;

	NSpace s;
	NObject[] objects;
 
	public Main()
	{
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e)
			{
				System.out.println("closing param=" + e.paramString());
				System.exit(0);
			}
		});

		addMouseMotionListener(new MouseMotionAdapter() {
			public void mouseDragged(MouseEvent e)
			{
				if ((e.getModifiers()&MouseEvent.BUTTON1_MASK)!=0)
				{
					x.set(0, e.getX()-w/2);
					x.set(1, h/2-e.getY());
				}
				else if ((e.getModifiers()&MouseEvent.BUTTON2_MASK)!=0)
				{
					x.set(1, e.getX()-w/2);
					x.set(2, h/2-e.getY());
				}
				else if ((e.getModifiers()&MouseEvent.BUTTON3_MASK)!=0)
				{
					x.set(2, e.getX()-w/2);
					x.set(0, h/2-e.getY());
				}
				s.setViewPoint(NFactory.makePoint(x));

				repaint();
			}
		});

		s = new NSpace(3);

		objects = new NObject[4];

		x = new NVector(w/2, -f, h/2);
		s.setViewPoint(NFactory.makePoint(x));

		s.setProjectionPlane(
				NFactory.makePlane(new NObject[]{
						NFactory.makePoint(new NVector(0, 0, 0)),
						NFactory.makePoint(new NVector(0, 0, h)),
						NFactory.makePoint(new NVector(w, 0, h)),
						NFactory.makePoint(new NVector(w, 0, 0)) }));

		objects[0] = NFactory.makePlane(new NObject[]{
				NFactory.makePoint(new NVector(  w/3,   f,   h/3)),
				NFactory.makePoint(new NVector(  w/3, 2*f, 2*h/3)),
				NFactory.makePoint(new NVector(2*w/3, 2*f, 2*h/3)),
				NFactory.makePoint(new NVector(2*w/3,   f,   h/3)) });
/*
		objects[1] = NFactory.makeTetraeder(new NObject[]{
				NFactory.makePoint(new NVector(  w/3,   f,   w/3)),
				NFactory.makePoint(new NVector(2*w/3,   f,   w/3)),
				NFactory.makePoint(new NVector(  w/3, 2*f,   w/3)),
				NFactory.makePoint(new NVector(  w/3,   f, 2*w/3)),
				NFactory.makePoint(new NVector(  w/3,   f,   w/3)) });
*/
		objects[1] = NFactory.makeTetraeder(3, w/4);
		objects[2] = NFactory.makeHexaeder(3, w/4);
		objects[3] = NFactory.makeOctaeder(3, w/4);
		System.out.println("line :"+objects[0].toString());
		System.out.println("Tetra:"+objects[1].toString());
		System.out.println("Cube :"+objects[2].toString());
		System.out.println("Octa :"+objects[3].toString());
		setSize((int)w, (int)h);
		show();
	}

	public void paint(Graphics g)
	{
		for (int i=0 ; i<objects.length ; i++)
			if (objects[i]!=null)
					objects[i].drawIn(s, g);
		g.drawString(x.toString(), 50, 50);
		super.paint(g);
	}
}
